class Particle
{
  PVector pointLoc;
  PVector pointForce;
  
  PVector loc;
  PVector vel;
  PVector acc;
  
  float dia;
  color colour;
  float fade;
  int lifespan;
  int age;
  
  PVector prvLoc;
  
  Particle (PVector _loc, PVector _pointLoc, color _colour) {
    
    pointLoc = _pointLoc;  
    pointForce = new PVector(0.001, 0.001);
    
    loc = _loc.get();        
    vel = new PVector(random(-10, 10), random(-10, 10));  //random(-0.75, 0.75), random(-0.75, 0.75));
    acc = new PVector(0, 0.0);
    
    dia = 10; 
    colour = _colour; 
    fade = 100;
    lifespan = 50;
    age = 0;
  }
  
  void update(float _input, ArrayList _particles)
  {
    //float distance = dist(loc.x, loc.y, pointLoc.x, pointLoc.y);
    
    //pointLoc = new PVector(mouseX-width/2,mouseY-height/2);
    
    pointForce = new PVector(loc.x - pointLoc.x, loc.y - pointLoc.y);
    
    ArrayList particles = _particles;
    
    for (int i = 0; i < particles.size(); i++) {
      
      Particle p = (Particle) particles.get(i);
      PVector particleRepel = new PVector(loc.x - p.loc.x, loc.y - p.loc.y); 
      particleRepel.mult(0.000002);
      //ArrayList test = _particles;
      
      //vel.mult(_input);
      
      //println(pointLoc.x + "  " + pointLoc.y);
      //println(loc.x + "  " + loc.y);
      pointForce.mult(0.001);
      //pointForce.limit(0.01);  
      acc.limit(0.01);
      acc.sub(pointForce);
      acc.add(particleRepel);
      acc.mult(_input);
      //acc.limit(0.1);
      vel.add(acc);
      //vel.mult(_input);
      
      
      //PVector randomise = new PVector(random(-1, 1), random(-1, 1));
      //vel.limit(0.8);
      vel.limit(0.3 + _input*0.8);
      
      
      //vel.add(randomise);
      loc.add(vel); 
     
    }
  }
  
  void velocityMod() {
    
    
  }
  
  void pointForce() {
        
  }
  
  Float getLocX() {
    return loc.x;  
  }
  
  Float getLocY() {
    return loc.y;  
  }
  
  
  void display(float _input) {
    //noStroke();
    strokeWeight(1 + _input*0.05);
    if (prvLoc == null) prvLoc = loc.get();
    
    line(loc.x,loc.y,prvLoc.x,prvLoc.y);
    
    //ellipse(loc.x, loc.y, 10, 10);
    prvLoc = loc.get();
  }
}
