class Ripple {
  
  float dia;
  color colour;
  float fade;
  int lifespan;
  int age;
  
  Ripple(float _dia, color _colour) {
    
    dia = _dia;   
    colour = _colour; 
    fade = 100;
    lifespan = 50;
    age = 0;
    
  }
  
  void update() {
    fade -= 5;
    if (fade<0) fade=0;
    age++;
    dia += 60;
  }
  
  void display() {
    //colour = color(colour, fade);
    stroke(colour, fade);
    ellipse(swidth/2, sheight/2, dia, dia);
  }
  
  boolean isDead() {       
    if (age >= lifespan) {
      return true;     
    }
    return false;
  }
  
}
